Index: serefpolicy-contrib-20140730/telepathy.if
===================================================================
--- serefpolicy-contrib-20140730.orig/telepathy.if
+++ serefpolicy-contrib-20140730/telepathy.if
@@ -2,45 +2,39 @@
 
 #######################################
 ## <summary>
-##	The template to define a telepathy domain.
+##	Creates basic types for telepathy
+##	domain
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix for the domain.
 ##	</summary>
 ## </param>
 #
 template(`telepathy_domain_template',`
 	gen_require(`
-		attribute telepathy_domain, telepathy_executable, telepathy_tmp_content;
+		attribute telepathy_domain;
+		attribute telepathy_executable;
 	')
 
 	type telepathy_$1_t, telepathy_domain;
 	type telepathy_$1_exec_t, telepathy_executable;
-	userdom_user_application_domain(telepathy_$1_t, telepathy_$1_exec_t)
+	application_domain(telepathy_$1_t, telepathy_$1_exec_t)
+	ubac_constrained(telepathy_$1_t)
 
-	type telepathy_$1_tmp_t, telepathy_tmp_content;
+	type telepathy_$1_tmp_t;
 	userdom_user_tmp_file(telepathy_$1_tmp_t)
 
+	kernel_read_system_state(telepathy_$1_t)
+
 	auth_use_nsswitch(telepathy_$1_t)
 ')
 
 #######################################
 ## <summary>
-##	The role template for the telepathy module.
+##	Role access for telepathy domains
+##	that executes via dbus-session
 ## </summary>
-## <desc>
-##	<p>
-##	This template creates a derived domains which are used
-##	for window manager applications.
-##	</p>
-## </desc>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user domain (e.g., user
-##	is the prefix for user_t).
-##	</summary>
-## </param>
 ## <param name="user_role">
 ##	<summary>
 ##	The role associated with the user domain.
@@ -51,10 +45,15 @@ template(`telepathy_domain_template',`
 ##	The type of the user domain.
 ##	</summary>
 ## </param>
+## <param name="domain_prefix">
+##	<summary>
+##	User domain prefix to be used.
+##	</summary>
+## </param>
 #
-template(`telepathy_role_template',`
+template(`telepathy_role',`
 	gen_require(`
-		attribute telepathy_domain, telepathy_tmp_content;
+		attribute telepathy_domain;
 		type telepathy_gabble_t, telepathy_sofiasip_t, telepathy_idle_t;
 		type telepathy_mission_control_t, telepathy_salut_t, telepathy_sunshine_t;
 		type telepathy_stream_engine_t, telepathy_msn_t, telepathy_gabble_exec_t;
@@ -63,91 +62,84 @@ template(`telepathy_role_template',`
 		type telepathy_mission_control_exec_t, telepathy_salut_exec_t;
 		type telepathy_sunshine_exec_t, telepathy_stream_engine_exec_t;
 		type telepathy_msn_exec_t;
-
-		type telepathy_mission_control_cache_home_t, telepathy_cache_home_t, telepathy_logger_cache_home_t;
-		type telepathy_gabble_cache_home_t, telepathy_mission_control_home_t, telepathy_data_home_t;
-		type telepathy_mission_control_data_home_t, telepathy_sunshine_home_t, telepathy_logger_data_home_t;
 	')
 
-	role $2 types telepathy_domain;
-
-	allow $3 telepathy_domain:process { ptrace signal_perms };
-	ps_process_pattern($3, telepathy_domain)
+	role $1 types telepathy_domain;
 
-	telepathy_gabble_stream_connect($3)
-	telepathy_msn_stream_connect($3)
-	telepathy_salut_stream_connect($3)
+	allow $2 telepathy_domain:process signal_perms;
+	ps_process_pattern($2, telepathy_domain)
 
-	dbus_spec_session_domain($1, telepathy_gabble_t, telepathy_gabble_exec_t)
-	dbus_spec_session_domain($1, telepathy_sofiasip_t, telepathy_sofiasip_exec_t)
-	dbus_spec_session_domain($1, telepathy_idle_t, telepathy_idle_exec_t)
-	dbus_spec_session_domain($1, telepathy_logger_t, telepathy_logger_exec_t)
-	dbus_spec_session_domain($1, telepathy_mission_control_t, telepathy_mission_control_exec_t)
-	dbus_spec_session_domain($1, telepathy_salut_t, telepathy_salut_exec_t)
-	dbus_spec_session_domain($1, telepathy_sunshine_t, telepathy_sunshine_exec_t)
-	dbus_spec_session_domain($1, telepathy_stream_engine_t, telepathy_stream_engine_exec_t)
-	dbus_spec_session_domain($1, telepathy_msn_t, telepathy_msn_exec_t)
+	telepathy_gabble_stream_connect($2)
+	telepathy_msn_stream_connect($2)
+	telepathy_salut_stream_connect($2)
+
+	dbus_session_domain($3, telepathy_gabble_exec_t, telepathy_gabble_t)
+	dbus_session_domain($3, telepathy_sofiasip_exec_t, telepathy_sofiasip_t)
+	dbus_session_domain($3, telepathy_idle_exec_t, telepathy_idle_t)
+	dbus_session_domain($3, telepathy_logger_exec_t, telepathy_logger_t)
+	dbus_session_domain($3, telepathy_mission_control_exec_t, telepathy_mission_control_t)
+	dbus_session_domain($3, telepathy_salut_exec_t, telepathy_salut_t)
+	dbus_session_domain($3, telepathy_sunshine_exec_t, telepathy_sunshine_t)
+	dbus_session_domain($3, telepathy_stream_engine_exec_t, telepathy_stream_engine_t)
+	dbus_session_domain($3, telepathy_msn_exec_t, telepathy_msn_t)
 
-	allow $3 { telepathy_mission_control_cache_home_t telepathy_cache_home_t telepathy_logger_cache_home_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 { telepathy_gabble_cache_home_t telepathy_mission_control_home_t telepathy_data_home_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 { telepathy_mission_control_data_home_t telepathy_sunshine_home_t telepathy_logger_data_home_t }:dir { manage_dir_perms relabel_dir_perms };
-
-	allow $3 { telepathy_mission_control_cache_home_t telepathy_cache_home_t telepathy_logger_cache_home_t }:file { manage_file_perms relabel_file_perms };
-	allow $3 { telepathy_gabble_cache_home_t telepathy_mission_control_home_t telepathy_data_home_t }:file { manage_file_perms relabel_file_perms };
-	allow $3 { telepathy_mission_control_data_home_t telepathy_sunshine_home_t telepathy_logger_data_home_t }:file { manage_file_perms relabel_file_perms };
-
-	filetrans_pattern($3, telepathy_cache_home_t, telepathy_gabble_cache_home_t, dir, "gabble")
-	# gnome_cache_filetrans($3, telepathy_gabble_cache_home_t, dir, "wocky")
-
-	filetrans_pattern($3, telepathy_cache_home_t, telepathy_logger_cache_home_t, dir, "logger")
-	# gnome_data_filetrans($3, telepathy_logger_data_home_t, dir, "TpLogger")
-
-	userdom_user_home_dir_filetrans($3, telepathy_mission_control_home_t, dir, ".mission-control")
-	filetrans_pattern($3, telepathy_data_home_t, telepathy_mission_control_data_home_t, dir, "mission-control")
-	# gnome_cache_filetrans($3, telepathy_mission_control_cache_home_t, file, ".mc_connections")
-
-	userdom_user_home_dir_filetrans($3, telepathy_sunshine_home_t, dir, ".telepathy-sunshine")
-
-	# gnome_cache_filetrans($3, telepathy_cache_home_t, dir, "telepathy")
-	# gnome_data_filetrans($3, telepathy_data_home_t, dir, "telepathy")
-
-	allow $3 telepathy_tmp_content:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 telepathy_tmp_content:file { manage_file_perms relabel_file_perms };
-	allow $3 telepathy_tmp_content:sock_file { manage_sock_file_perms relabel_sock_file_perms };
+	telepathy_dbus_chat($2)
 ')
 
 ########################################
 ## <summary>
-##	Connect to gabble with a unix
-##	domain stream socket.
+##	Stream connect to Telepathy Gabble
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`telepathy_gabble_stream_connect',`
+interface(`telepathy_gabble_stream_connect', `
 	gen_require(`
 		type telepathy_gabble_t, telepathy_gabble_tmp_t;
 	')
 
-	files_search_tmp($1)
 	stream_connect_pattern($1, telepathy_gabble_tmp_t, telepathy_gabble_tmp_t, telepathy_gabble_t)
+	files_search_tmp($1)
 ')
 
 ########################################
 ## <summary>
-##	Send dbus messages to and from
-##	gabble.
+##	Allow Telepathy Gabble to stream connect to a domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
 #
-interface(`telepathy_gabble_dbus_chat',`
+interface(`telepathy_gabble_stream_connect_to', `
+	gen_require(`
+		type telepathy_gabble_t;
+	')
+
+	stream_connect_pattern(telepathy_gabble_t, $2, $2, $1)
+')
+
+########################################
+## <summary>
+##	Send DBus messages to and from
+##	Telepathy Gabble.
+## </summary>
+## <param name="domain">
+## 	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`telepathy_gabble_dbus_chat', `
 	gen_require(`
 		type telepathy_gabble_t;
 		class dbus send_msg;
@@ -159,10 +151,10 @@ interface(`telepathy_gabble_dbus_chat',`
 
 ########################################
 ## <summary>
-##	Read mission control process state files.
+##	Read telepathy mission control state.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
@@ -173,15 +165,12 @@ interface(`telepathy_mission_control_rea
 	')
 
 	kernel_search_proc($1)
-	allow $1 telepathy_mission_control_t:dir list_dir_perms;
-	allow $1 telepathy_mission_control_t:file read_file_perms;
-	allow $1 telepathy_mission_control_t:lnk_file read_lnk_file_perms;
+	ps_process_pattern($1, telepathy_mission_control_t)
 ')
 
 #######################################
 ## <summary>
-##	Connect to msn with a unix
-##	domain stream socket.
+##	Stream connect to telepathy MSN managers
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -189,19 +178,18 @@ interface(`telepathy_mission_control_rea
 ##	</summary>
 ## </param>
 #
-interface(`telepathy_msn_stream_connect',`
+interface(`telepathy_msn_stream_connect', `
 	gen_require(`
 		type telepathy_msn_t, telepathy_msn_tmp_t;
 	')
 
-	files_search_tmp($1)
 	stream_connect_pattern($1, telepathy_msn_tmp_t, telepathy_msn_tmp_t, telepathy_msn_t)
+	files_search_tmp($1)
 ')
 
 ########################################
 ## <summary>
-##	Connect to salut with a unix
-##	domain stream socket.
+##	Stream connect to Telepathy Salut
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -209,11 +197,140 @@ interface(`telepathy_msn_stream_connect'
 ##	</summary>
 ## </param>
 #
-interface(`telepathy_salut_stream_connect',`
+interface(`telepathy_salut_stream_connect', `
 	gen_require(`
 		type telepathy_salut_t, telepathy_salut_tmp_t;
 	')
 
-	files_search_tmp($1)
 	stream_connect_pattern($1, telepathy_salut_tmp_t, telepathy_salut_tmp_t, telepathy_salut_t)
+	files_search_tmp($1)
+')
+
+#######################################
+## <summary>
+##	Send DBus messages to and from
+##	all Telepathy domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`telepathy_dbus_chat',`
+	gen_require(`
+		attribute telepathy_domain;
+		class dbus send_msg;
+	')
+
+	allow $1 telepathy_domain:dbus send_msg;
+	allow telepathy_domain $1:dbus send_msg;
+')
+
+######################################
+## <summary>
+##	Execute telepathy executable
+##	in the specified domain.
+## </summary>
+## <desc>
+##	<p>
+##	Execute a telepathy executable
+##	in the specified domain.  This allows
+##	the specified domain to execute any file
+##	on these filesystems in the specified
+##	domain. 
+##	</p>
+##	<p>
+##	No interprocess communication (signals, pipes,
+##	etc.) is provided by this interface since
+##	the domains are not owned by this module.
+##	</p>
+## </desc>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+## <param name="target_domain">
+##	<summary>
+##	The type of the new process.
+##	</summary>
+## </param>
+#
+interface(`telepathy_command_domtrans', `
+	gen_require(`
+		attribute telepathy_executable;
+	')
+
+	allow $2 telepathy_executable:file entrypoint;
+	domain_transition_pattern($1, telepathy_executable, $2)
+	type_transition $1 telepathy_executable:process $2;
+
+	# needs to dbus chat with unconfined_t and unconfined_dbusd_t
+	optional_policy(`
+		telepathy_dbus_chat($1)
+		telepathy_dbus_chat($2)
+	')
+')
+
+########################################
+## <summary>
+##	Create telepathy content in the user home directory
+##	with an correct label.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`telepathy_filetrans_home_content',`
+	gen_require(`
+		type telepathy_mission_control_cache_home_t;
+		type telepathy_mission_control_home_t;
+		type telepathy_logger_cache_home_t;
+		type telepathy_gabble_cache_home_t;
+		type telepathy_sunshine_home_t;
+		type telepathy_logger_data_home_t;
+		type telepathy_cache_home_t, telepathy_data_home_t;
+		type telepathy_mission_control_data_home_t;
+	')
+
+	filetrans_pattern($1, telepathy_cache_home_t, telepathy_logger_cache_home_t, dir, "logger")
+	filetrans_pattern($1, telepathy_cache_home_t, telepathy_logger_cache_home_t, file, "sqlite-data-journal")
+	filetrans_pattern($1, telepathy_cache_home_t, telepathy_gabble_cache_home_t, dir, "gabble")
+
+	filetrans_pattern($1, telepathy_data_home_t, telepathy_mission_control_data_home_t, dir, "mission-control")
+
+	userdom_user_home_dir_filetrans($1, telepathy_mission_control_home_t, dir, ".mission-control")
+	userdom_user_home_dir_filetrans($1, telepathy_sunshine_home_t, dir, ".telepathy-sunshine")
+
+	optional_policy(`
+		gnome_cache_filetrans($1, telepathy_mission_control_cache_home_t, file, ".mc_connections")
+		gnome_cache_filetrans($1, telepathy_gabble_cache_home_t, dir, "gabble")	
+		gnome_cache_filetrans($1, telepathy_gabble_cache_home_t, dir, "wocky")
+		gnome_cache_filetrans($1, telepathy_cache_home_t, dir, "telepathy")
+
+		gnome_data_filetrans($1, telepathy_logger_data_home_t, dir, "TpLogger")
+		gnome_data_filetrans($1, telepathy_data_home_t, dir, "telepathy")
+	')
+')
+
+######################################
+## <summary>
+##	Execute telepathy in the caller domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`telepathy_exec',`
+	gen_require(`
+		attribute telepathy_executable;
+	')
+
+	corecmd_search_bin($1)
+	can_exec($1, telepathy_executable)
 ')
